Documentation Index
Fetch the complete documentation index at: https://cdktn.io/docs/llms.txt
Use this file to discover all available pages before exploring further.
Initializer
using Io.Cdktn;
new DataTerraformRemoteStateGcsConfig {
System.Collections.Generic.IDictionary<string, object> Defaults = null,
string Workspace = null,
string Bucket,
string AccessToken = null,
string Credentials = null,
string EncryptionKey = null,
string ImpersonateServiceAccount = null,
string[] ImpersonateServiceAccountDelegates = null,
string KmsEncryptionKey = null,
string Prefix = null,
string StoreageCustomEndpoint = null
};
Properties
| Name | Type | Description |
|---|
Defaults | System.Collections.Generic.IDictionary< string, object > | No description. |
Workspace | string | No description. |
Bucket | string | (Required) The name of the GCS bucket. |
AccessToken | string | (Optional) A temporary [OAuth 2.0 access token] obtained from the Google Authorization server, i.e. the Authorization: Bearer token used to authenticate HTTP requests to GCP APIs. This is an alternative to credentials. If both are specified, access_token will be used over the credentials field. |
Credentials | string | (Optional) Local path to Google Cloud Platform account credentials in JSON format. |
EncryptionKey | string | (Optional) A 32 byte base64 encoded ‘customer supplied encryption key’ used to encrypt all state. |
ImpersonateServiceAccount | string | (Optional) The service account to impersonate for accessing the State Bucket. |
ImpersonateServiceAccountDelegates | string[] | (Optional) The delegation chain for an impersonating a service account. |
KmsEncryptionKey | string | (Optional) A Cloud KMS key (‘customer-managed encryption key’) used when reading and writing state files in the bucket. |
Prefix | string | (Optional) GCS prefix inside the bucket. |
StoreageCustomEndpoint | string | (Optional) A URL containing three parts: the protocol, the DNS name pointing to a Private Service Connect endpoint, and the path for the Cloud Storage API (/storage/v1/b). |
DefaultsOptional
public System.Collections.Generic.IDictionary<string, object> Defaults { get; set; }
- Type: System.Collections.Generic.IDictionary< string, object >
WorkspaceOptional
public string Workspace { get; set; }
BucketRequired
public string Bucket { get; set; }
(Required) The name of the GCS bucket.
This name must be globally unique.
AccessTokenOptional
public string AccessToken { get; set; }
(Optional) A temporary [OAuth 2.0 access token] obtained from the Google Authorization server, i.e. the Authorization: Bearer token used to authenticate HTTP requests to GCP APIs. This is an alternative to credentials. If both are specified, access_token will be used over the credentials field.
CredentialsOptional
public string Credentials { get; set; }
(Optional) Local path to Google Cloud Platform account credentials in JSON format.
If unset, Google Application Default Credentials are used.
The provided credentials must have Storage Object Admin role on the bucket.
Warning: if using the Google Cloud Platform provider as well,
it will also pick up the GOOGLE_CREDENTIALS environment variable.
EncryptionKeyOptional
public string EncryptionKey { get; set; }
(Optional) A 32 byte base64 encoded ‘customer supplied encryption key’ used to encrypt all state.
ImpersonateServiceAccountOptional
public string ImpersonateServiceAccount { get; set; }
(Optional) The service account to impersonate for accessing the State Bucket.
You must have roles/iam.serviceAccountTokenCreator role on that account for the impersonation to succeed.
If you are using a delegation chain, you can specify that using the impersonate_service_account_delegates field.
Alternatively, this can be specified using the GOOGLE_IMPERSONATE_SERVICE_ACCOUNT environment variable.
ImpersonateServiceAccountDelegatesOptional
public string[] ImpersonateServiceAccountDelegates { get; set; }
(Optional) The delegation chain for an impersonating a service account.
KmsEncryptionKeyOptional
public string KmsEncryptionKey { get; set; }
(Optional) A Cloud KMS key (‘customer-managed encryption key’) used when reading and writing state files in the bucket.
Format should be projects/{{project}}/locations/{{location}}/keyRings/{{keyRing}}/cryptoKeys/{{name}}.
For more information, including IAM requirements, see Customer-managed Encryption Keys.
PrefixOptional
public string Prefix { get; set; }
(Optional) GCS prefix inside the bucket.
Named states for workspaces are stored in an object called < prefix >/< name >.tfstate.
StoreageCustomEndpointOptional
public string StoreageCustomEndpoint { get; set; }
(Optional) A URL containing three parts: the protocol, the DNS name pointing to a Private Service Connect endpoint, and the path for the Cloud Storage API (/storage/v1/b).
See here for more details